#include <stdio.h>
#include <pthread.h>

#include <caml/mlvalues.h>
#include <caml/memory.h>
#include <caml/callback.h>

value g_closure;

CAMLprim value register_cb (value clos)
{
	CAMLparam1 (clos);

	printf("--- register_cb\n"); fflush(stdout);

	register_global_root(&g_closure);
	g_closure = clos;

	CAMLreturn (Val_unit);
}

void *thr_main (void *arg)
{
	printf("--- thr_main\n");
	callback(g_closure, Val_unit);
}

void create_thr()
{
	pthread_t thr;
	pthread_create(&thr, NULL, thr_main, NULL);
}

CAMLprim value run_cb_segfault (value unit)
{
	CAMLparam1 (unit);
	printf("--- run_cb_segfault\n"); fflush(stdout);
	create_thr();
	CAMLreturn (Val_unit);
}

CAMLprim value run_cb (value unit)
{
	CAMLparam1 (unit);
	printf("--- run_cb\n"); fflush(stdout);
	callback(g_closure, Val_unit);
	CAMLreturn (Val_unit);
}

